﻿using System;

namespace Helios.Source
{
    public class SolarPanel
    {
        public double Efficiency { get; set; }
        public double CostPerMetreSquared { get; set; }
        public double InstallationCost { get; set; }
        public double PowerOutput { get; set; }
        public double CostPerWatt { get; set; }


        public SolarPanel() { }

        public SolarPanel(double efficiency, double costPerMetreSquared)
        {
            Efficiency = efficiency;
            CostPerMetreSquared = costPerMetreSquared;
        }


        public double GetInstallationCost(double area)
        {
            double installationCost;

            installationCost = area * CostPerMetreSquared;

            this.InstallationCost = installationCost;

            return installationCost;
        }

        public double GetPowerOutput(int roofArea, int roofElevation)
        {
            double powerOutput;

            powerOutput = Efficiency * 1000 * roofArea * Math.Sin(roofElevation);

            this.PowerOutput = powerOutput;

            return powerOutput;
        }

        public double GetCostPerWatt()
        {
            double costPerWatt;

            costPerWatt = this.InstallationCost * this.PowerOutput;

            this.CostPerWatt = costPerWatt;

            return costPerWatt;
        }

    }

}